



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP的输出缓冲区</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP的输出缓冲区</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 01:16:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>什么是缓冲区?</strong><br />简单而言,缓冲区的作用就是,把输入或者输出的内容先放进内存,而不显示或者读取.至于为什么要有缓冲区,这是一个很广泛的问题,如果有兴趣,可以在网山找下资料.<br />其实缓冲区最本质的作用就是,协调高速CPU和相对缓慢的IO设备(磁盘等)的运作.</p>
<p><strong>PHP在执行的时候,在什么地方有用到缓冲区?</strong><br />想要了解PHP的缓冲区,就要知道执行PHP的时候,缓冲区被设置到了什么地方.<br />当执行PHP的时候,如果碰到了echo print_r之类的会输出数据的代码,PHP就会将要输出的数据放到PHP自身的缓冲区,等待输出.<br />当PHP自身的缓冲区接到指令,指示要输出缓冲区的内容时,将会把缓冲区内的数据输出到apache上, apache接受到PHP输出的数据,然后再把该数据存在到apache自身的缓冲区内,等到输出<br />当apache接受到指令,只是要输出缓冲区的内容时, 将会把缓冲区的内容输出,返回到浏览器.</p>
<p>由此可见,PHP要输出数据的时候,将会经过两个缓冲区(先是自身的,然后是apache的),再返回到浏览器.</p>
<p><strong>缓冲区在PHP中起到什么作用?</strong><br />1.最常见的就是在使用header函数之前,就已经输出了某些数据,这样会导致某些错误,例如 Cannot modify header information &ndash; headers already sent by;</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>echo</code>&nbsp;<code>"this is test"</code><code>;</code></div>
<div><code>header(</code><code>"LOCATION <a href="http://www.baidu.com/" rel="external nofollow noreferrer">http://www.baidu.com</a>"</code><code>);</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>出现这个错误的原因是, 在header之前已经输出了某些数据,而输出这些数据的同时, apache将会同时发送一个响应状态到浏览器上(既然有输出,即这个请求是有效的),而其后你又再次使用header函数<br />发送http头,则会返回这个错误,错误的意思是:HTTP头已经发送出去了,你不能对他再做修改.<br />为什么使用缓冲区可以避免这个错误呢?<br />因为header函数是不受缓冲区影响的,当一碰到header函数的时候,PHP马上执行apache发送这一个http头都浏览器.<br />而输出的数据PHP打开输出缓冲区后, 这些数据将会存放在缓冲区,等待输出.这样就可以避免了之前所发生的错误.<br />2.通过PHP写文件下载程序的时候.<br />为了让文件下载更安全,同时提高更多的可控性,很多朋友都喜欢用PHP写文件下载页面.其原理很简单,就是通过fwrite把文件内容读出并显示,然后通过header来发送HTTP头,让浏览器知道这是一个附件,这样<br />就可以达到提供下载的效果.<br />如果用上面的办法提供下载页面,会碰到一个效率问题,如果一个文件很大,假设为100M,那么在不开启缓冲区输出的情况下,必须要把100M数据全部读出,然后一次返回到页面上,如果这样做,用户将会在所有数据读完<br />之后才会得到响应,降低了用户体验感.<br />如果开启了输出缓冲区,当PHP程序读完文件的某一段,然后马上输出到apache,然后让apache马上返回到浏览器,这样就可以减少用户等待时间.那后面的数据怎么办呢?我们可以写一个while循环,一直一段一段地读取文件<br />每读一段,就马上输出,直到把文件全部输出为止,这样浏览器就可以持续地接受到数据,而不必等到所有文件读取完毕.</p>
<p>另外,该做法还解决了另外一个很严重的问题.例如一个文件是100M,如果不开启缓冲区的情况下,则需要把100M文件全部读入内存,然后再输出.但是,如果PHP程序做了内存限制呢?为了保证服务器的稳定,管理员通常会把PHP的执行<br />内存设一个限制(通过php.ini总的memory_limit, 其默认值是8M), 也就是每个PHP程序使用的内存不能使用超过这个值的内存. 假设该值为8M,而要读入的文件是100M,根本就没有足够的内存来读入该文件.这个时候,我们就需要用到上面的<br />办法来解决这个问题,每次只读某一段,这样就可以避免了内存的限制<br />3.静态文件缓存<br />现在很多公司有这么一个需求, 就是某一个页面在第一次访问的时候,会执行PHP,然后把显示的内容返回到浏览器,同时需要把这次显示的内容保存到服务器上,这样下次访问的时候,就直接把保存在服务器上的文件直接显示,而不需要通过PHP来做操作<br />这就是所谓的&rdquo;静态页面缓存&rdquo;.那怎么样才能做到把内容返回到浏览器的同时把数据保存到服务器上呢?这就要用到输出缓冲区了.</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
</td>
<td>
<div>
<div><code>ob_start();</code></div>
<div><code>echo</code>&nbsp;<code>'aaa'</code><code>;</code></div>
<div><code>$string</code>&nbsp;<code>= ob_get_contents();</code></div>
<div><code>file_put_contents</code><code>(</code><code>'a.html'</code><code>, </code><code>$string</code><code>);</code></div>
<div><code>ob_flush();</code></div>
<div><code>flush</code><code>();</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><strong>与输出缓冲区有关的配置</strong><br />在PHP.INI中,有两个跟缓冲区紧密相关的配置项<br />1.output_buffering<br />该配置直接影响的是php本身的缓冲区,有3种配置参数.on/off/xK(x为某个整型数值);<br />on&nbsp;&nbsp; &nbsp;- 开启缓冲区<br />off&nbsp;&nbsp; &nbsp;- 关闭缓冲区<br />256k&nbsp;&nbsp; &nbsp;- 开启缓冲区,而且当缓冲区的内容超过256k的时候,自动刷新缓冲区(把数据发送到apache);</p>
<p>2.implicit_flush<br />该配置直接影响apache的缓冲区,有2种配置参数. on/off<br />on&nbsp;&nbsp; &nbsp;- 自动刷新apache缓冲区,也就是,当php发送数据到apache的缓冲区的时候,不需要等待其他指令,直接就把输出返回到浏览器<br />off&nbsp;&nbsp; &nbsp;- 不自动刷新apache缓冲区,接受到数据后,等待刷新指令<br /><strong><br />与缓冲区有关的函数</strong><br />1.ob_implicit_flush<br />作用和implicit_flush一样,是否自动刷新apache的缓冲区<br />2.flush<br />作用是发送指令到apache,让apache刷新自身的输出缓冲区.<br />3.ob_start<br />打开输出缓冲区,无论php.ini的文件如何配置,如果使用该函数,即使output_buffering设置成off,也会打开输出缓冲区<br />ob_start函数还接受一个参数,该参数是一个函数的回调,意思是,在输入缓冲区内容之前,需要使用调用传递进来的参数把缓冲区的内容处理一次,再放入缓冲区内<br />4.ob_flush<br />指示php本身刷新自身的缓冲区,把数据发送到apache<br />5.ob_clean<br />清除php缓冲区里面的内容<br />6.ob_end_clean<br />清除php缓冲区内的内容,并且关闭输出缓冲区<br />7.ob_end_flush<br />把php自身的缓冲区里的内容发送到apache,并把清除自身缓冲区内的内容<br />8.ob_get_clean<br />获取缓冲区的内容之后,清除缓冲区.<br />9.ob_get_contents<br />获取输出缓冲区里的内容<br />10.ob_get_flush<br />获取缓冲区里的内容,并且把这些内容发送到apache<br />11.ob_get_length<br />获取缓冲区里内容的长度<br />12.ob_list_handlers<br />获取运行ob_start时,所回调的函数名称, 例如:<br />ob_start(&lsquo;ob_gzhandler&rsquo;);<br />print_r(ob_list_handlers);<br />将打印出ob_gzhandler;<br />13.ob_gzhandler<br />该函数的作用是作为ob_start的回调参数, 在缓冲区刷新之前,会调用该函数对数据进行到底gzip或者deflate压缩.这个函数需要zlib扩展的支持.</p>
<p><strong>使用缓冲区的相关内容</strong><br />1.ob_flush和flush的次序关系.上面的分析可以看出,ob_flush是和php自身相关的,而flush操作的是apache的缓冲区,所有我们在使用这两个函数的时候,需要先执行ob_flush,<br />再执行flush,因为我们需要先把数据从PHP上发送到apache,然后再由apache返回到浏览器.如果php还没有把数据刷新到apache,就调用了flush,则apache无任何数据返回到浏览器.</p>
<p>2.有的浏览器,如果接受到的字符太少,则不会把数据显示出来,例如老版的IE(必须要大于256k才显示).这样就会造成一个疑问, 明明在php和apache都进行了刷新缓冲区的操作,但是浏览器就是没有出现自己想要的数据,也许就是这个原因造成的.所以才测试的时候,可以在输出数据的后面加上多个空格,以填满数据,确定不会浏览器造成这类诡异的问题.</p>
<p>3.有些webserver,他自身的输出缓冲区会有一些限制,比如nginx,他有一个配置fastcgi_buffer_size&nbsp;4k, 就是是表明,当自身的输出缓冲区的内容达到4K才会刷新,所以为了保证内容的数据,可以添加以下代码,保证内容长度</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
</td>
<td>
<div>
<div><code>&lt;?php</code></div>
<div>&nbsp;</div>
<div><code>echo</code>&nbsp;<code>str_repeat</code><code>(</code><code>" "</code><code>,4096);</code></div>
<div>&nbsp;</div>
<div><code>?&gt;</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>4.在apache中,如果你开启了mod_gzip的压缩模块,这样可能会导致你的flush函数刷新不成功,其原因是,mod_gzip有自己的输出缓冲区,当php执行了flush函数,指示apache刷新输出缓冲区,但是内容需要压缩,apache就把内容输出到自身的mod_gzip模块,mod_gzip也有自身的输出 缓冲区,他也不会马上输出,所以造成了内容不能马上输出.为了改善这个情况,可以关闭mod_gzip模块,或者在httpd.conf增加以下内容,以禁止压缩</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
</td>
<td>
<div>
<div><code>SetEnv&nbsp;no-gzip&nbsp;dont-vary</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div>原文链接：http://www.keepmyway.com/index.php/124.html</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m9633649.html">Android log 管理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9px4k7q.html">C&num;按行读取文本并存放再数组内</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2v70o8.html">servlet中的相对路径和绝对路径 及&sol;&comma; &period;&sol;&comma; &period;&period;&sol;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jpex8.html">web开发注意的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd0jlgq.html">Struts2 url传递中文出现乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0x4jgq.html">Linux下Qt环境的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7mk1q.html">jQuery事件绑定和委托</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1z1kz9.html">&period;NET 面试题（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzz4748.html">SpringAop进行日志管理。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzmgmg8.html">深入理解java回调机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd5gxd9.html">beta 分布的详细介绍（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5x248.html">插件开发之360 DroidPlugin源码分析（四）Activity预注册占坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjovm39.html">&lbrack;20190214&rsqb;11g Query Result Cache RC Latches补充&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2enp19.html">Optimizing Hive queries for ORC formatted tables</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjm10j9.html">Python&lowbar;每日习题&lowbar;0007&lowbar;copy</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15lylq.html">poj2942 求v-DCC，二分图判奇环，补图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6zjv9.html">Oracle DBA最常用的269条命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/953revm8.html">M1事后总结报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvr5ogq.html">2018-2019-2 网络对抗技术 20165202 Exp5 MSF基础应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm20rg9.html">mongodb 如何区分大小写</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93x4l6z9.html">灵活性比Listview更好的RecycleView</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z7ng69.html">Linux学习计划</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1zped9.html">富文本 SpannableString Span</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yovmjq.html">常用的CSS属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdgm7k8.html">Memcached应用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok665p9.html">智能SQL优化工具－－SQL Optimizer for SQL Server（帮助提升数据库应用程序性能，最大程度地自动优化你的SQL语句 ）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wzzzlq.html">CentOS 5 64bit  编译安装MySQL报错</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wz45wq.html">MyEclipse汉化后问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0o5ewq.html">JAVA-1-HelloWorld</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok6x459.html">64位系统中开启32位应用，特别是OLEDB</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
